/*
        MemView 1.10 -=- Anzeige der DOS-internen Speicherbelegung

        Compiler: Microsoft C
        by Marcus Grber 1989-93

     This product  supports the  TesSeRact(TM)  Standard  for  Ram-Resident
     Program Communication.   For  information about TesSeRact, contact the
     TesSeRact Development Team at:
     
          TesSeRact Development Team
          c/o Chip Rabinowitz
          2084 Woodlawn Avenue
          Glenside, PA 19038
          1-215-884-3373
     
          Compuserve:    70731,20
          MCIMAIL:       315-5415
     
     This MCIMAIL  Account has  been provided  to the TesSeRact Development
     Team by Borland International, Inc.  The TesSeRact Development Team is
     in no  way associated with Borland International, Inc.  TesSeRact is a
     trademark of the TesSeRact Development Team.

*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <conio.h>
void (_interrupt _far *_aintdiv)(void);         /* Zero-Divide-Vektor, undok. */

#include "mv.h"
#include "mv_tool.h"
#include "mv_blkls.h"
#include "mv_analy.h"
#include "mv_disp.h"

char copyright[]="\r\nMemView 1.10 - MS/PC/DR-DOS MemoryMap - "
                     "by Marcus Grber, "__DATE__"\r\n\r\n";
/*----------------------------------------------------------------------------*/
int opt_progcomp=1;             /* Nur einen Block pro Programm anzeigen */
int opt_subblocks=0;            /* Unterblcke eines Bereichs anzeigen */
int opt_userints=0;             /* User-Interrupts (C0h-FFh auch anziegen?) */
int opt_irets=0;                /* Auch Vektoren mit IRET anzeigen */
unsigned opt_width=80;          /* 40/74/80-Zeichen-Modus? */
int opt_keep=0;                 /* Eigene Daten nicht lschen */
int opt_terse=0;                /* Kompakte Ausgabe */
int opt_verbose=0;              /* Debugging-Ausgabe */
int opt_xmem=0;                 /* Extended/Expanded-Memory */
int opt_showother=0,opt_showfree=0,opt_showhard=0,opt_showbios=0,opt_showscb=0,
    opt_showsys=0;              /* Welche Zusatz-Daten anzeigen? */
int opt_showall=1;              /* Alle Programme anzeigen */

int num_moreMCBs;               /* Anzahl weiterer MCB-Strukturen */
unsigned moreMCBs[10];          /* Liste weiterer MCB-Strukturen */

int num_shownames;              /* Anzahl der Namen fr selektive Anzeige */
char shownames[16][9];          /* Namen fr selevtive Anzeige */

int dos4owner=0;                /* DOS 4.0-komp. MCBs? (auch DR-DOS >=5.0) */
int dos4scb=0;                  /* DOS 4.0-komp. SCBs? (auch DR-DOS >=6.0) */
int drdosumb=0;                 /* DR-DOS 5.0-komp. Upper Memory? */

/*----------------------------------------------------------------------------*/
int EMSvers=-1;                 /* EMS-System vorhanden? Welche Version? */
int XMSvers=-1;                 /* XMS-System vorhanden? Welche Version? */

struct MemBlDesc *FirstBlkDesc; /* Zeiger auf DIE Hauptliste */
struct PSP far *MyPSP;          /* Zeiger auf eigenen PSP */
long MaxSize;                   /* Maximaler freier TPA-Bereich */
long TotalEMS;                  /* Gesamt-EMS-Kapazitt */
long FreeEMS;                   /* Freie EMS-Kapazitt */
long DosEMS;                    /* In DOS-Speicher "gemapptes" EMS */
long ExtTotal;                  /* Gesamt-Extended-Memory */
long FreeXMS;                   /* Freie XMS-Kapazitt */


/*----------------------------------------------------------------------------*/
#define debug(msg) if(opt_verbose) _cprintf(msg"\r\n")

/*----------------------------------------------------------------------------*/
int evalargs(int argc,char **argv)
{
        int i,j;
        char *p,c;
        int opt_subblocks=0;

        num_moreMCBs=0;                 /* Noch keine weiteren MCBs gefunden */
        num_shownames=0;                /* Noch keine Namen angegeben */
        for(i=1;i<argc;i++)             /* Alle Argumente durchgehen */
          if(argv[i][0]=='/' || argv[i][0]=='-')
                                        /* Nur Switches beachten */
            switch(toupper(argv[i][1])) {
                                        /* Switches auswerten */
              case 'D':                 /*** /D: "D"etailed (SMAP-komp.) */
                opt_progcomp=0;         /* Nicht nur eine Zeile pro Programm */
                break;
              case 'I':                 /*** /I: Auch "I"RETs anzeigen */
                opt_irets=1;            /* Auch Interrupts auf IRET zeigen */
                break;
              case 'M':                 /*** /M: Zustzliche "M"CB-Strukturen */
                moreMCBs[num_moreMCBs++]=(unsigned)strtol(&argv[i][2],&p,16);
                break;
              case 'N':                 /*** /N: Eigenen Block "N"icht freig. */
                opt_keep=1;             /* Block in Liste belegt lassen */
                break;
              case 'R':                 /*** /R: "R"OMs bercksichtigen */
                opt_showbios=opt_showhard=1;             
                break;                  /* ROMs und Hardware anzeigen */
              case 'S':                 /*** /S: "S"ystem-Unterblcke */
                opt_subblocks=1;        /* Unterblcke */
                break;
              case 'T':                 /*** /T: "T"erse (knappe Ausgabe) */
                opt_terse=1;            
                break;
              case 'U':                 /*** /U: "U"ser-Interrupts zeigen */
                opt_userints=1;         /* Auch Interrupts C0h-FFh zeigen */
                break;
              case 'V':                 /*** /V: "V"erbose: Debug-Infos */
                opt_verbose=1;          /* Debug-Informationen anzeigen */
                break;
              case 'X':                 /*** /X: E"x"tended/E"x"panded Memory */
                opt_xmem=1;             /* Auch X-Speicher anzeigen */
                break;
              case '4':                 /*** /4: "4"0-Zeichen-Modus */
                opt_width=40;           /* Keine technischen Infos */
                break;
              case '7':                 /*** /7: "7"4-Zeichen-Modus */
                opt_width=74;           /* Technische Infos krzen */
                break;
              case '?':                 /*** /?: Syntax */
                _cprintf(copyright);
                _cprintf("MV [optionen] [@infos] {progname...}\r\n");
                _cprintf(" Optionen:\r\n");
                _cprintf("   /d: <D>etailliert: Alle Blcke          /i: Auch Interrupts auf <I>RETs\r\n");
                _cprintf("   /mXXXX: Zustzliche <M>CBs ab XXXX      /n: MemView-Blocks <N>icht freigeben\r\n");
                _cprintf("   /r: BIOS-<R>OMs, Hardwareadressen       /s: <S>ystem-Unterblcke zeigen\r\n");
                _cprintf("   /t: <T>erse: Nur Blockliste ausgeben    /u: Auch <U>ser-INTs (INT C0h-FFh)\r\n");
                _cprintf("   /v: <V>erbose: Debug-Infos ausgeben     /x: e<X>tended/e<X>panded-Memory\r\n");
                _cprintf("   /4: <4>0-Zeichen-Modus                  /7: <7>4-Zeichen-Modus\r\n");
                _cprintf("   /?: Diese bersicht\r\n");
                _cprintf(" Infos:\r\n");
                _cprintf("    F: freies RAM       S:System            R: BIOS-ROM         H: Hardware\r\n");
                _cprintf("    X: andere/unbekannt\r\n");
                return 1;               /* Keine Anzeige */
              default:                  /*** unbekannter Switch */
                _cprintf("Ungltiger Parameter: %s\r\n"
                         "MV /? zeigt Syntax\r\n",argv[i]);
                return 1;               /* Fehlermeldung - abbrechen */
            }
          else {
            if(argv[i][0]=='@')
              for(j=1;c=(char)toupper(argv[i][j]);j++)
                switch(c) {
                  case 'S':             /*** @S zeigt Systemblcke an */
                    opt_showsys=1;
                    break;
                  case 'F':             /*** @F zeigt freie Blcke an */
                    opt_showfree=1;
                    break;
                  case 'H':             /*** @H zeigt Hardware-Adressen an */
                    opt_showhard=1;
                    break;
                  case 'R':             /*** @R zeigt BIOS-ROM an */
                    opt_showbios=1;
                    break;
                  case 'X':             /*** @X zeigt sonstige Blcke an */
                    opt_showother=1;
                    break;
                }
            else {
              strncpy(shownames[num_shownames],argv[i],8);
                                        /* Namen in Liste bernehmen */
              shownames[num_shownames][(_osmajor==4)?7:8]='\0';
                                        /* Nach 8 Zeichen ist immer Ende (unter
                                           DOS 4.xx fehlt in den MCB-Besitzer-
                                           namen das achte Zeichen) */
              strupr(shownames[num_shownames++]);
                                        /* In Grobuchstaben und weiter */
            }
            opt_showall=0;              /* Nicht alle Programme anzeigen */
          }
        if(opt_showall)                 /* Keine Anzeige-Beschrnkungen? */
          opt_showsys=opt_showfree=opt_showother=1;
                                        /* default-Anzeigemodus */
        if(opt_subblocks)               /* System-Unterblocks anzeigen? */
          opt_showscb=opt_showsys;      /* Ja, falls System gewnscht */
        return 0;                       /* Alles okay */
}

/*----------------------------------------------------------------------------*/
void main(int argc,char **argv)
{
        int drmaj;

        if(evalargs(argc,argv))         /* Parameter auswerten */
          return;                       /* Fehlerhafte Parameter: Abbruch */

        if(!opt_terse)                  /* Keine verkrzte Ausgabe? */
          _cprintf(copyright);          /* Dann Copyright anzeigen */

        if(!opt_keep)                   /* Eigenen Block freigeben? */
          _dos_setvect(0x00,_aintdiv);  /* Zero-Divide restaurieren */

        if(_osmajor>=4) {
          dos4owner=1;                  /* Ab DOS 4.xx Besitzername in MCBs */
          dos4scb=1;                    /* Ab DOS 4.xx SCB-Strukturen vorh. */
        }

        drmaj=getdrmajor();             /* Sonderbehandlungen fr DR-DOS */
        if(drmaj>=5) {
          dos4owner=1;                  /* MCBs ab DR 5.0 komp. zu MS 4.0 */
          drdosumb=1;                   /* DR 5.0+ hat eigene UMB-Verwaltung */
        }

        FirstBlkDesc=NULL;              /* Noch keine Blcke da */

debug("Lesen der Systemzeiger...");
        LoadPointers();                 /* Systeminterne Zeiger lesen */
debug("XMS-Belegung feststellen...");
        GetXMSData();                   /* XMS-Daten holen */
debug("Einlesen der Speicherblcke...");
        LoadMCBs();                     /* MCB-Blcke einlesen */
debug("Programmnamen bestimmen...");
        LoadPrograms();                 /* Programmnamen/-infos einlesen */
debug("EMS-Belegung feststellen...");
        GetEMSData();                   /* EMS-Daten holen */
debug("ROM-Bereiche suchen...");
        LoadROMs();                     /* ROM-Blcke identifizieren */
debug("Videospeicher lokalisieren...");
        LoadVideo();                    /* Videospeicher suchen */
debug("Gertetreiber suchen...");
        LoadDevices();                  /* Gertetreiber laden */
debug("Interruptvektoren prfen...");
        LoadInterrupts();               /* Interruptvektoren analysieren */
debug("TesSeRact-Programme suchen...");
        LoadTesSeRact();                /* TesSeRact-Programme suchen */
        if(opt_progcomp) {              /* Zusammenfassung gewnscht? */
debug("Programme sortieren...");
          SortByProgram();              /* Ja: Sortierung nach Programm-PSPs */
        }
debug("");
        ListMemory();                   /* Belegung 1. Megabyte */
        if(opt_xmem) {
          EMSInfo();                    /* EMS-Belegung */
          XMSInfo();                    /* XMS-Belegung */
        }
}
