/*
        MemView -=- Anzeige der DOS-internen Speicherbelegung

        Compiler: Microsoft C
        by Marcus Grber 1989-93

        Allerhand Hilfsroutinen
*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>


void call86x(void far *p,union REGS far *rin,
             union REGS far *rout,struct SREGS far *sr)
/*
   Analog zu int86x: Aufrufen einer far-Routine mit Registerbergabe
*/
{
_asm {
        push    si              ; C wnscht SI, DI, Segmentregister und
        push    di              ; Direction-Flag unverndert
        push    ds
        push    es
        pushf

        lds     si,sr           ; DS:SI = sr
        push    [si]sr.ds       ; Segmentregister konfigurieren
        mov     es,[si]sr.es

        lds     si,rin          ; DS:SI = rin
        mov     ax,[si]rin.x.ax ; Andere Register programmieren
        mov     bx,[si]rin.x.bx
        mov     cx,[si]rin.x.cx
        mov     dx,[si]rin.x.dx
        mov     di,[si]rin.x.di
        mov     si,[si]rin.x.si
        pop     ds

        push    bp              ; C-Sicherheit
        call    far ptr p       ; Interrupt-Routine anspringen
        pop     bp

        push    ds
        push    si

        lds     si,rout         ; DS:SI = rout
        mov     [si]rout.x.ax,ax; Datenregister speichern
        mov     [si]rout.x.bx,bx
        mov     [si]rout.x.cx,cx
        mov     [si]rout.x.dx,dx
        mov     [si]rout.x.di,di
        pushf                   ; Flagregister in AX verfgbar machen
        pop     ax
        and     ax,1            ; Carry isolieren
        mov     [si]rout.x.cflag,ax ; C-Flag speichern
        pop     [si]rout.x.si

        lds     si,sr           ; DS:SI = sr
        mov     [si]sr.es,es    ; Segmentregister speichern
        pop     [si]sr.ds

        popf
        pop     es
        pop     ds
        pop     di
        pop     si
}}

/*----------------------------------------------------------------------------*/
unsigned _normal(void far *ptr)
/*
   Segmentadresse zurckgeben, die bei Normalisierung des Pointers (d.h.
   Reduzierung auf Offset 0000h-000Fh) entstehen wrde.
*/
{
        unsigned seg=FP_SEG(ptr)+(FP_OFF(ptr)>>4);
                                        // eff. Segmentadresse des Pointers
        return seg<FP_SEG(ptr) ? 0xFFFF:seg;
                                        // Wraparound: Immer 0xFFFF
}

/*----------------------------------------------------------------------------*/
long _phys(void far *ptr)
/*
   Physikalische 32-Bit-Adresse des Zeigers ermitteln (fr Vergleiche der
   effektiven Adresse).
*/
{
        return ((long)FP_SEG(ptr)<<4)+FP_OFF(ptr);
                                                /* _phys=Seg*16+Off */
}

/*----------------------------------------------------------------------------*/
void far *_ptr(unsigned seg,unsigned ofs)
/*
   Zeiger aus Segment und Offset zusammensetzen.
*/
{
        return (void far *)(((long)seg<<16)+(long)ofs);
}

/*----------------------------------------------------------------------------*/
void Get8Chars(unsigned char *name,unsigned char far *p)
{
        int len;

        len=8;                          /* Maximal 8 Zeichen lesen */
        for(;*p==' ' && len;p++,len--)  /* Blanks berlesen (fr NWCACHE :-)) */
          ;
        for(;*p!='\0' && *p!='.' && len;p++,len--)
                                        /* Zeichenweise bis Extension/Ende */
          *(name++)=(unsigned char)toupper(*p);
                                        /* Zeichen um Zeichen holen */
        *name='\0';                     /* Endnull fr Namen */
}


/*----------------------------------------------------------------------------*/
void NameFromPath(unsigned char *name,unsigned char far *p)
{
        unsigned char far *p2;

        p2=p;                           /* default: Dateiname ohne Pfad */
        for(;*p!='\0';p++)              /* Zeichenweise bis Stringende */
          if(*p==':' || *p=='\\' || *p=='/')
                                        /* Pfadnamenstrenner? */
            p2=p+1;                     /* Dann bis hierher garantiert nichts */
        Get8Chars(name,p2);             /* Dateinamen holen */
}
